/*************************************************
Wysanie SMS-a po naciniciu przycisku

UWAGA: przystosowany do pracy z telefonami
GSM firmy Siemens M/S/C35
*************************************************/
#define _TEST

#pragma DEFJ(TIM1_INIT=0xFD)	//Timer 1 jako zegar UART (19200,n,8,1)
											//warto TH1 = 0xFD dla 11,0592 MHz
#pragma SMALL							//wybr modelu pamici

#include <stdio.h>					//funkcje wejciawyjcia
#include <string.h>				//operacje na acuchach
#include <siemens35.h>			//biblioteka obsugi Siemens35
#include <reg8252.h>				//definicje rejestrw AT89S8252
#include <eeprom8252.h>			//biblioteka funkcji obsugi pamici 
											//EEPROM AT89S8252

//definicje staych
#define OFF 	0
#define ON		1

#define WORD unsigned int
#define BYTE unsigned char

//wyjcie przeczajce "powki" multipleksera
sbit NIBBLE = P3^2;
//definicja zewntrzna komunikatu wysyanego przez program
extern code char TEKSTPOWIADOMIENIA[];
//zmienna oglnego przeznaczenia
data BYTE temp;
//zmienna zawierajca stan czujnikw
data BYTE SENSORS;


//sygnalizacja bdu za pomoc LED: 2 krtkie byski+0,5s przerwy
void communicationerror()
{
	while(1)
	{
		SCK = 0; delay(80);
		SCK = 1; delay(150);
		SCK = 0; delay(80);
		SCK = 1; delay(500);
	}
}

//odczyt wej czujnikw alarmowych (stan zwracany w SENSORS,
//aktywna 1)
void readsensors()
{
	BYTE r1;

	NIBBLE = 0;					//odczyt powki umownie uznanej za starsz
	SENSORS = (P1 << 4) & 0xF0;
	NIBBLE = 1;					//odczyt powki umownie uznanej za modsz
	r1 = P1;
	r1 &= 0x0F;
	SENSORS |= r1;				//sumowanie obu powek
	SENSORS = ~SENSORS;		//teraz "1" jest stanem aktywnym, podczas 
										//gdy zadziaanie czujki wymusza "0"
}

//program gwny
void main()
{
	WMCON |= 0x02;				//zerowanie timera watchdog
	WMCON &= 0xFE;				//zatrzymanie watchdoga, jeli uK zosta												//zrestartowany
	SCK = 0;							//zaczenie LED
	delay(1000);					//czas na stabilizacj warunkw pracy
	PCON |= 0x80;					//ustawienie bitu preskalera zegara 
										//transmisji
	if (!initgsm())				//funkcja zwraca warto TRUE, jeli 
										//inicjalizacja telefonu przebiega 
										//pomylnie, jeli bd komunikacji 
										//z telefonem, to jest on
		communicationerror();	//sygnalizowany szybkim mruganiem LED

//------------------ GWNA PTLA PROGRAMU ------------------
	while (1)
	{
		SCK = 0;						//zaczenie diody LED
		WMCON |= 0x02;			//zerowanie timera watchdog
		readsensors();			//odczyt czujnikw, warto odczytu 
										//w zmiennej SENSORS
		delay(100);  				//aktywnemu czujnikowi odpowiada stan 
										//logiczny "1"
		SCK = 1;							
		delay(400);
		if (SENSORS != 0)		//jeli zmienna ma warto !=0,to aktywne 
										//jest wejcie
		{
		  delay(100);				//ponowny odczyt dla upewnienia si
		  readsensors();
		  if (SENSORS != 0)
		  {
			SCK = 0;					//zaczenie diody LED
			sendsms(TEKSTPOWIADOMIENIA);
										//wysanie komunikatu SMS
			delay(3000);			//"przerwa" okoo 3 sekund (czas wiecenia 
										//LED)
			SCK = 1;					//wyczenie diody LED
		  }
		}
	}
}
